*                 CORRIGE DE L'EXERCICE CHAPITRE 1 - EXERCICE 1
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C1EX1 avant d'ouvrir le do.fileC1EX1 qui est fichier programme.
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer les calculs de l'exercice. Il sera exécuté dans son intégralité.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.

* CHAPITRE 1 - EXERCICE 1
* Calcul d'un coefficient de corrélation

* 1) La première étape de l'exercice consiste à faire le graphique entre les deux variables. 

*Le programme Stata du graphe est donné par :

twoway (line y x ), ytitle("Quantités d'engrais") xtitle("Rendement")

* Vous obtenez le graphique ci-après. 

* 2) La deuxième étape de l'exercice consiste à calculer le coefficient de corrélation.
*Pour ce faire il faut créer une colonne pour les variables x2, y2 et x*y nécessaires aux calculs.
* créer une variable sous stata se fait avec le code "generate". 
* Le programme Stata est le suivant :
generate x2 =x^2
generate y2=y^2
generate xy=x*y

*Il faut aussi faire les sommes des colonnes x2 y2 et xy. 
*Le programme Stata est le suivant :
egen sumx=sum(x)
egen sumy=sum(y)
egen sumx2=sum(x2)
egen sumy2=sum(y2)
egen sumxy=sum(x*y)

*Il faut faire le tableau récupérant les différents calculs précédents.
*Le programme Stata est le suivant :
mkmat x x2 y y2 sumy sumx sumy2 sumxy, mat(tableau1)
mat list tableau1 

*On peut à présent calculer le coefficient avec la formule du livre.

*Avec _N=10 le nombre d'observations. 
* Le programme Stata est le suivant :

generate coefcor=[(_N*sumxy)-(sumx*sumy)]/[[(_N*sumx2)-(sumx^2)]^(1/2)*[(_N*sumy2)-(sumy^2)]^(1/2)]

*On peut au final afficher la valeur du coefficient de corrélation simple
display coefcor

*On peut aussi calculer le coefficient de détermiation R2 comme le carré du coefficient de corrélation simple
generate R2=coefcor^2
*Afficher la valeur du coefficent
display R2

*2) Dans la 2ème étape de l'exercice on veut savoir si le coefficient de corrélation entre x et y
* est significativement différend de 0. 
*Le calcul du t selon la formule du cours est données aavec _N=10 le nombre d'observations (_N)

gen tstudent=abs(coefcor)/sqrt((1-R2)/(_N-2))
display tstudent

*La valeur du t calculé est supérieur au t de la table qui est 2.36. Le coefficient est significativement 
* différent de 0.

* Mais il y a plus simple avec Stata. Il suffit de demander à stata de calculer le coefficient entre les variables.
* On peut inqdiquer un seuil de significativité calculé avec un risque de 1ere espèce de 5%(stata met une étoile (star) 
* pour indiquer la significativité (sig) grâce à une seule ligne de code sans executer les calculs précécédents.
pwcorr x y, sig star(5)


