*CORRIGE DE L'EXERCICE CHAPITRE 10- EXERCICE 3
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C10EX3 avant d'ouvrir le do.fileC10EX3 qui est le fichier programme. 
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run  (Execute en haut à droite de la barre de menu du dofile)
*  pour démarrer le programme. Il sera exécuté dans son intégralité.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.
 
 *                          CHAPITRE 10 EXERCICE 3
 * Analyse d'une fonction de réponse impulsionnelle et décomposition de la variance
 
 *Dans l'exercice précédant  (CH10 EX2) la représentation du var était celle d'un var(1)
 gen trimestres=(_n)
 tsset trimestres
 
 regress y1 L.y1 L.y2
 regress y2 L.y1 L.y2
 
 var y1 y2, lag(1)
 varstable , graph
 
 * varstable permet de vérifier les conditions de stabilité : ici il est stable car toutes les valeurs propres 
 *sont à l'intérieure du cercle unitaire.
 
 * Les fonctions de réponses impulsionnelles
 
 irf create var1, step(20) set(myirfs) replace

* Fonctions de réponses impulsionelle 
irf table oirf , impulse(y1) response(y1)
irf table oirf , impulse(y1) response(y2)
irf table oirf , impulse(y2) response(y1)
irf table oirf , impulse(y2) response(y2)

* Les graphes
irf graph  oirf, impulse(y1) response(y1)
irf graph  oirf, impulse(y2) response(y1) 


* On peut aussi utiliser sous stata la procédure varbasic qui donne l'estimation du var et l'ensemble des graphes.

varbasic y1 y2, lag(1)

irf set vardécomp
irf create vardécomp, step(10) replace
irf table fevd


* Il faut lire les résultats comme des % : 
* A la dernière période, la décomposition de la variance indique que la variance de l'erreur de prévision de y1 est de 81% 
* (avec un intervalle de confiance de 66% à 96%) à ses propres innovations et de 32% à celles de y2 (avec un intervalle de confiance
* de 12% à 51%).
* La variance de l'erreur de prévision de y2 est de 18%% (avec un intervalle de confiance de 3% à 33%) à ses propres innovations et de 67% à celles
*de y2 (avec un intervalle de confiance de 48% à 87%).

