*CORRIGE DE L'EXERCICE CHAPITRE 10- EXERCICE 4
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C10EX4 avant d'ouvrir le do.fileC10EX4 qui est le fichier programme. 
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run  (Execute en haut à droite de la barre de menu du dofile).
*  pour démarrer le programme. Il sera exécuté dans son intégralité.
  
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.
 
 *                          CHAPITRE 10 EXERCICE 4
 *                           Test de causalité de Granger et Sims
 
 gen trimestres=(_n)
 tsset trimestres
 
 * Les résultats du var sont donnés par:  
 var y1 y2, lag(1)
 
 *//// Test de Granger
 
 * Nous testons l'étape 1 y2 ne cause pas y1.
 * Le modèle non contraint est donné par 
 regress y1 L.y1 L.y2
 
 * Les résidus du modèle non contraint sont donnés par:  
 scalar RSSnc=e(rss)
 display RSSnc
 
  * Le modèle  contraint est donné par : 
 regress y1 L.y1 
 
 * Les résidus du modèle  contraint sont donnés par  (on test la nullité du coefficient de y2) : 
 * c=1 une seule contrainte à tester
 scalar RSSc=e(rss)
 display RSSc
 
 * Le test de Fisher est donné par :
 
 scalar Fstar=((RSSc - RSSnc)/1)/(RSSnc/(_N-2-1))
 display Fstar
 
 * Fstar=21 > F de la table (=4), On rejette H0, y2 explique significativement y1, donc y2 cause y1
 
 * Plutôt que le calcul on peut faire le test sous stata avec le code vargranger qui calcule directement les stat.
 *la valeur du Khi2:
 var y1 y2
 vargranger
 
 * On notera que les résulats précédents indiquent que y1 ne cause pas y2. Mais on peut le démontrer avec le calcul du
 *Fisher
 
 * Nous testons l'étape 1 y1 ne cause pas y2
 
 * Le modèle non contraint est donné par :
 regress y2 L.y1 L.y2
 
 * Les résidus du modèle non contraint sont donnés par ;
 scalar RSSnc2=e(rss)
 display RSSnc2
 
  * Le modèle  contraint est donné par :
 regress y2 L.y2 
 
 * Les résidus du modèle  contraint sont donnés par  (on test la nullité du coefficient de y2) :
 * c=1 une seule contrainte à tester
 scalar RSSc2=e(rss)
 display RSSc2
 
 * Le test de Fisher est donné par :
 
 scalar Fstar2=((RSSc2 - RSSnc2)/1)/(RSSnc2/(_N-2-1))
 display Fstar2
 
 * Fstar=3.63 < F de la table (=4), On accepte H0, y1 n'explique pas significativement y2, donc y1 ne cause pas y2
 
 
 *//////Test de Sims

 * Le modèle non contraint est donné par (F de forward permet d'utiliser la valeur de t+1 de y2):
 regress y1 L.y1 L.y2 F.y2
  scalar RSSnc3=e(rss)
 display RSSnc3
 
 * Le modèle contraint est donné par :
  regress y1 L.y1 L.y2 if trimestre <71
  scalar RSSc3=e(rss)
 display RSSc3

 scalar Fstar3=((RSSc3 - RSSnc3)/1)/(RSSnc3/(70-3-1))
 display Fstar3

 * On rejette l'hypothèse H0, yt+2 explique significativement y1, il y a signifiactivité au sens de Sims. y2 cause y1
 
 * Testons y2 ne cause pas y1
 
* Le modèle non contraint est donné par (F de forward permet d'utiliser la valeur de t+1 de y1) :
 regress y2 L.y1 L.y2 F.y1
  scalar RSSnc4=e(rss)
 display RSSnc4
 
 * Le modèle contraint est donné par 
  regress y2 L.y1 L.y2 if trimestre <71
  scalar RSSc4=e(rss)
 display RSSc4

 scalar Fstar4=((RSSc4 - RSSnc4)/1)/(RSSnc4/(70-3-1))
 display Fstar4
 
 * Selon Sims il y a bien une causalité de y2 vers y1 (causalité de type feedback)
