*CORRIGE DE L'EXERCICE CHAPITRE 11-EXERCICE 1
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C11EX1 avant d'ouvrir le do.fileC11EX1 qui est le fichier programme. 
  
*Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
*pour démarrer le programme. Il sera exécuté dans son intégralité.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.
  
 
                                 * CHAPITRE 11 EXERCICE 1
                                * Test de cointégration et modèles à correction d'erreur
 
 gen temps=(_n)
 tsset temps
 
 */// L'étape 1 consiste à tester les séries en termes de stationnarité
 
 ******* LES TESTS ADF
 
 ********variable x  - test ADF
 
* Modèle 3 variable x
dfuller x, trend  regress

* Il y a une racine et la tendance n'a pas de coefficient significatif

* Modèle 2 variable x
dfuller x,  regress
 
 * Il y a une racine et la dérive n'a pas de coefficient significatif
 
* modèle 1 variable x
 
 dfuller x, noconstant regress
 
* La présence de la racine est confirmée. On passera la variable en différence première
gen Dx=d.x
corrgram Dx
 
 ********variable y - test ADF
 
 * Modèle 3 variable y
dfuller y, trend  regress

* Il y a une racine et la tendance n'a pas de coefficient significatif

* Modèle 2 variable y
dfuller y,  regress
 
 * Il y a une racine et la dérive n'a pas de coefficient significatif
 
 * Modèle 1 variable y 
 dfuller y, regress noconstant
 
* La présence de la racine est confirmée. On passera la variable en différence première

gen Dy=d.y
corrgram Dy

 
 ******* LES TESTS P.Perron
 
 ********variable x - test PPerron
 
 pperron x, trend lag(2) regress
 
 * Il y a racine unitaire et le trend n'est pas significatif

  
 pperron x,  lag(2) regress
 
 * Il y a racine unitaire et la dérive n'est pas significatif

  pperron x,  lag(2) noconstant regress
 
 * Il y a racine unitaire il faut passer en différence première
 
  
  ********variable y - test PPerron
 
 pperron y, trend lag(2) regress
 
 * Il y a racine unitaire et le trend n'est pas significatif

  
 pperron y,  lag(2) regress
 
 * Il y a racine unitaire et la dérive n'est pas significatif

  pperron y,  lag(2) noconstant regress
 
 * Il y a racine unitaire il faut passer en différence première

 
  ******* LES TESTS KPSS
 
 ********variable x - test Kpss
 
kpss x, trend maxlag(2)

kpss x,  maxlag(2) notrend

 
 * Il y a racine unitaire il faut passer en différence première
 
   ********variable y - test Kpss
 
kpss y, trend maxlag(2)

kpss y,  maxlag(2) notrend

*  
* Dans la mesure où tous les tests convergent, on effecture la régression mco de y/x en niveau. 
* Il faut récupérer les résidus de la relation de long terme et vérifier qu'ils sont stationnaires
 
 regress y x
 predict residus, re
 
 dfuller residus
 * Ils sont stationnaires nous procédons au MCE avec les résidus retardés

regress Dy Dx L.residus

*Le coefficient du résidu retardé (la force de rappel) est bien significatif et négatif. La représentatrion du MCE est validée.
 


 
 
  dfuller residus 
  dfuller residus, noconstant 
 
 pperron residus
 pperron residus, noconstant
 
