*CORRIGE DE L'EXERCICE CHAPITRE 12-EXERCICE 1
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C12EX1 avant d'ouvrir le do.fileC12EX1 qui est le fichier programme. 
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run  (Execute en haut à droite de la barre de menu du dofile) 
* pour démarrer le programme. Il sera exécuté dans son intégralité.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.
  
 
 *                         CHAPITRE 12 EXERCICE 2
 *                          Estimation de modèle logit probit binaire
 
 
 * Question 1 : Estimation logit du modèle
 
 logit reussite genre necono nenfants nmicro
 
 * A la lecture du résultat nous constatons que la variable micro n'est pas significative (prob 0.41), que nenfant à une
 * prob de 0.07 et donc que la variable est faiblement significative. Seules genre est necono sont significatives
 
 * Nous refaisons une estimation en enlevant les variables non significatives. Nous utilisons "fitstat" pour obtenir un certain
 * nombre de statistiques utiles à l'analyse du Logit
 
 logit reussite genre necono nenfants
  fitstat
  
* Log-lik intercept (LR) est le log Likelihood ; Log-lik full model (LU) est le Restr. Log Likelihood. 
* On peut aussi calculer avec LU/n = -0.25 le Avg. Log Likelihood qui n'est pas donné par Stata mais que l'on calcule aisément. 
* LR(3df) est la  LR statistic. Vous avez aussi les critères d'information (AIC, BIC)

* a) Interprétation statistique de la régression logit

***** Les coefficients sont tous significativement différents de zéro, hormis le terme constant. La statistique de la 
* Log vraisemblance LR = 53,35 que l'on compare à un Khi2 à 3ddl, nous rejetons H0, le modèle comporte au moins une variable explicative
* Le pseudo R2=MacFadden= 0.63 = 1- (LU/LR) = 1 - (-15.377)/(-41.55) = 1 - 0.37=0.63. Le modèle est validé

* Le logiciel Stata propose une table permettant d'appréhender les qualités prévisionnelles du modèle sur l'échantillon
* en comparant la probabilité estimée pour un individu i d'être = 1 (P(dep=1)) au seuil arbitraire de 50% à la valeur observée 
* des yi=0 ou des yi=1

 logit reussite genre necono nenfants
 estat classification
 
 * Dans l'échantillon on a 29 individus qui ont raté leur examen (yi=0),le modèle indique que  26 individus ont une probabilité estimée 
 * de réussite inférieure à 50%. Donc dans 89,66% des cas les échecs ont été correctement prévus par le modèle. 
 * Pour les individus (31 au total) pour lesquels yi=1, le modèle indique que 27 individus ont une probabilité estimée de réussite à
 * l'examen supérieure à 50%. Donc dans 87,1% des cas les réussites sont correctement prévues.
 
 * Dans ce modèle le taux d'erreur de prévision est faible
 
 * b) Interprétation économique.
 
* Le modèle s'écrit (en arrondisant les coefficents estimés)

*Ln(Pi/(1-Pi))= -3.63 genre + 0.70 necono -0.75 nenfants -2.86 +ei
 
* Le nombre de frères et soeurs agit négativement sur le taux de réussite. Les étudiants issus de familles nombreuses ont un taux de 
* réussite plus faible.
* La note d'économétrie est un facteur positif de réussite. Enfin les garçons réussissent en général moins bien que les filles.


* Question 2 : Estimation d'un modèle Probit et du modèle linéraire général.

* Le modèle probit
probit  reussite genre necono nenfants
  fitstat

* Les valeurs des  coefficients sont de même signe mais de valeurs différentes par rapport au modèle Logit car la spécification
*n'est pas la même. Cependant on peut retrouver les valeurs du Logit en multiplinant les coefficients par 1.81.
  
  * Le modèle MCO 
  
regress reussite genre necono nenfants

* Les coefficients sont affectés du même signe que dans les modèles probit et logit. Cependant le graphe des valeurs ajustées ci-après
* indique que les valeurs sont parfois négatives ou supérieures à 1 ce qui est incompatible avec la valeur d'une probabilité.


predict e, re
gen yprédit=reussite-e

 twoway (line  yprédit obs)
 
* Question 3 : comment lire les résultats

* soit 1 étudiant dont les caractéristiques sont les suivantes :
*     - Nenfants = 1 , necono= 12, genre= masculin. Le modèle nous donne alors comme résultats: 
* Log(Pi/1-P1) = -0,75*nenafant +0,70* noécono - 3.63*genre - 2.86 + résidu
* Log(Pi/1-P1) = -0,75*1 +0,70*12 - 3.63*1 - 2.86 = 1.109
* exp.1.109 = Pi/(1-Pi) =3.033 et donc P= 75% de chance de réussir à son examen de licence
 