*CORRIGE DE L'EXERCICE CHAPITRE 12-EXERCICE 2
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C12EX2 avant d'ouvrir le do.fileC12EX2 qui est le fichier programme. 
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer le programme. Il sera exécuté dans son intégralité.
 
 * Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.
  
 
 *                                   CHAPITRE 12 EXERCICE 2
                                     * Estimation d'un modèle à choix multiples de prévisions de ventes
 
 * 1)  Une première estimation de type logit nouos donne
 
 ologit vente direct expo reduc we

 * La variable direct a un coefficient qui n'est pas significatif on peut  retirer la variable de la spécification

 ologit vente  expo reduc we
 estat ic 

 *** a) Intreprétation statistique
 
 * Les coefficients sont maintenant tous significatifs. La statistique de la log vraisemblance est égale à LR=37;33.
 * Etant donné la probailité du test le modèle est donc validé, au moins une des variables à un coefficient significatif.
 
 *** b) Interprétation économique
 
 * La durée d'exposition et le pourcentage de réduction agissent positivement sur les ventes.
 * Une emission diffusée un jour de semaine engendre moins de ventes qu'une emission diffusée le we.
 * Les seuils (cut1 et cut2) sont respectivement de 3.679 et 6.170.
 
 *Le logiciel Stata ne propose pas directement de table permettant d'appréhender les qualités prévisionnelles du modèle 
* comme dans le cas du logit/probit où il suffit d'écrire après l'estimation "estat classification". Il faut utiliser ici un petit
*programme  comme suit :

ologit vente  expo reduc we
predict p1 p2 p3 

egen maxpred = rowmax(p1-p3)
gen vpredites = .
forval i = 1/3 {
replace vpredites = `i' if p`i' == maxpred
}
tab2 vente vpredites

* P1, p2, P2 sont les colonnes de probabilités associées aux modalités 0,1,2 respectivement

* A la lecture du résultat on peut constater que les qualités prévisionnelles de ce modèle ne sont pas négligeable puique pour 
* les ventes de niveau 0, il y a a 44 dans l'échantillon et le modèle en estime 47, soit une erreur de prévision 3
* pour les ventes de niveau niveau 1, l'échantillon en compte 27, le modèle en prévoit 31 soit une erreur de prévision de 4.
* Dans le dernier car l'erreur de prévision est de 7.

ologit vente  expo reduc we

 gen valatente=_b[expo]*expo+_b[reduc]*reduc+_b[we]*we

prvalue


