*CORRIGE DE L'EXERCICE CHAPITRE 13-EXERCICE 1
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C13EX1 avant d'ouvrir le do.fileC13EX1 qui est le fichier programme. 
  
*  Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run  (Execute en haut à droite de la barre de menu du dofile)
*  pour démarrer le programme. Il sera exécuté dans son intégralité.

* Il est possible en sélectionnant les étapes du programme de l'exécuter pas à pas.
  
 
                                   * CHAPITRE 13 EXERCICE  1
                              *Procédure séquentielle des tests d'homogéneité
 
 * Tout d'abord il s'agit de faire une régression sur données empilées et de récupérer les résidus du modèle non contraint. RSSnc
 
 regress y x1 x2
 scalar SCRC=e(rss)
 display SCRC
 
 * SCRC est le modèle MCO empilé (contraint.
 * Puis on fait 9 estimations (une par pays) puis on récupére les SCRc contrainte qui est égale à la somme des 9 SCR. 
 * Le modèle suivant organise une boucle  pour i=1..9 pays pour récupérer les 9 SCR
  
 local i = 1
 while `i' <=9{
regress y x1 x2 if pays == `i'
scalar scr=e(rss)
display scr
local i = `i' + 1
}

* On peut faire la somme de chacune des valeurs pour obtenir SCR des modèles non contraints

generate scr = 2757341 in 1/9
replace scr = 211063.8 in 2
replace scr = 84306563 in 3
replace scr = 82876299 in 4
replace scr = 150121.7 in 5
replace scr = 7419022 in 6
replace scr = 2771928  in 7
replace scr = 2793154 in 8
replace scr = 297885.1 in 9

egen SCRNC=sum(scr)
display SCRNC

* On fait à présent le test des données empilées contre la somme des 9 modèles

scalar F1= (SCRC - SCRNC)/24/(SCRNC/198)
display F1

* On note que F1 calculé est supérieur au F de la table on rejette H0. Les coefficients ne sont pas égaux 
* (constante et vecteurs des coefficients)

* Nous testons (branche gauche du graphique de l'ouvrage) à présent le côté gauche du graphique.* c'est à dire que nous
* avons rejeté l'hypothèse d'homogénéité totale pour tester le vecteur des coefficients des variables
* (a'i = a')

tsset pays Année
xtreg y x1 x2, fe
scalar SCRC2=e(rss)
display SCRC2

*On peut stocker sous le nom de la variable fe, la liste des effets fixes  (cross)
predict fe, u

*On peut aussi les afficher à l'écran
scalar _1_C= fe in 1
scalar _2_C= fe in 26
scalar _3_C= fe in 51
scalar _4_C= fe in 76
scalar _5_C= fe in 101
scalar _6_C= fe in 126
scalar _7_C= fe in 151
scalar _8_C= fe in 177
scalar _9_C= fe in 202
display _1_C
display _2_C
display _3_C
display _4_C
display _5_C
display _6_C
display _7_C
display _8_C
display _9_C

* on peut à présent faire le test du modèle contraint (effets fixes) contre le modèle empilé

scalar F2= (SCRC2 - SCRNC)/16/(SCRNC/198)
display F2

* Nous rejetons HO, les coefficients ai sont identiques d'un équation a l'autre. Nous testons à présent
* la constante

* Le modèle non contraint est le modèle à effet fixe (une constante différente par pays)
* Le modèle contraint devient le MCO empilé où il y a une contrainte de constante unique pour chaque pays

scalar F3 = (SCRC - SCRC2)/8/(SCRC2/213)
display F3

* F3 > 190 nous rejetons HO. Les constantes sont différentes d'un pays à l'autre. 
* Le panel à une structure a effets fixes.
