 *                 CORRIGE DE L'EXERCICE CHAPITRE 2 - EXERCICE 2
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C2EX2 avant d'ouvrir le do.fileC2EX2 qui est fichier programme.
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer les calculs de l'exercice. Il sera exécuté dans son intégralité.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.


*PARTIE 1 DE L'EXERCICE : Estimation des coefficients de régression.

* Etape 1: Les calculs du tableau 3 de l'exercice.
*Il s'agit dans cet exercice de calculer les coefficients estimés a1 et a0. Il faut tout d'abord faire la moyenne de y et x.

egen xbarre=mean(x)
egen ybarre=mean(y)

* Donner les valeurs des moyennes nommées xbarre et ybarre.

display xbarre 
display ybarre

* Créer les colonnes des écarts aux moyennes (x-xbarre) et (y-ybarre)

gen ecarty=y-ybarre
gen ecartx=x-xbarre

*Créer la colonne de l'écart à la moyenne de x au carré  (ecartx)^2

gen ecartxcarré=(ecartx)^2

*Créer la colonne de l'écart de x à sa moyenne multiplié par l'écart de y à sa moyenne nommée : ecartx*ecarty

gen ecartxy=ecarty*ecartx

*Faire le tableau récapitulatif des différentes valeurs calculées

mkmat y x ecartxcarré ecartxy, mat(Tableau3)
mat list Tableau3

*Faire la somme des colonnes

egen sumecartxy=sum(ecartxy)
egen sumecartxcarre=sum(ecartxcarré)

* On peut afficher les valeurs des sommes.

display sumecartxy
display sumecartxcarre

*Etape 2 : On peut à présent calculer a1, le coefficient de x

gen a1=sumecartxy/sumecartxcarre
display a1

*Calculer a0 le coefficient de la constante.

gen a0=ybarre-a1*xbarre
display a0
