 *                 CORRIGE DE L'EXERCICE CHAPITRE 2 - EXERCICE 3
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C2EX3 avant d'ouvrir le do.fileC2EX3 qui est fichier programme.
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer les calculs de l'exercice. Il sera exécuté dans son intégralité.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.

*L'exercice 3 utilise le fichier de données de l'exercice 2. C'est également la suite de l'exercice 2. Certains élements de l'exercice 2
* sont ici réutilisés et ne sont donc pas recalculés.


* L'EXERCICE : Test de Coefficient et intervalle de confiance

* La question qui se pose est : la propension marginale à consommer est - elle significativement différente de zéro ?

*Etape 1 : Faire le test de coefficients et intervalle de confiance 

* Il s'agit de calculer l'écart_type estimé de a1 que l'on notera sigma1. 
* De l'exercice 2 nous connaissons la somme des écarts au carré de y qui est égale à 64156 000. Nous devons calculer 
* l'estimateur de la variance de l'erreur.

* Il faut pour se faire calculer la colonne des y estimés, des résidus (e) et des résidus au carré (e2). Tous les éléments sont obtenus
*après une régression :

regress y x
predict e, residual
predict yestimé, xb
gen e2=e^2

* Il nous faut faire la somme des carrés des résidus et calculer la moyenne

egen carrédesrésidu=sum(e2)
display carrédesrésid
egen moyennnedescarrés=mean(e2)
display moyennnedescarrés

mkmat yestimé e e2, mat(tableau4)
matlist tableau4


* Calcul de l'estimation de la variance de l'erreur (nommé variancedesrésidus) et de l'ecart type du coefficient de régression 
gen variancedesrésidus=carrédesrésidu/(10-2)
display variancedesrésidus

*Calculer la variance et l'écart type de a1 selon la formule de l'ouvrage, nommée ecarttypeestiméa1

gen variancea1=variancedesrésidus/64156000
display variancea1

gen ecarttypeestiméa1=sqrt(variancea1)
display ecarttypeestiméa1

* Le calcul du ratio de Student et règle de décision. _b[x] nous donne le coefficient a1.
* Le calcul du ratio empirique de student est donné par :
gen ta1=_b[x]/ecarttypeestiméa1
display ta1

* Le t calculé est supérieur au t de la table. Le coefficient est donc significatif.

*Le calcul de l'intervalle de confiance (0,73 - 0,82) avec un risque de première espèce à 5%.

gen intervallebas=_b[x]-(ecarttypeestiméa1*2.306)
display intervallebas
gen abornehaute=_b[x]+(ecarttypeestiméa1*2.306)
display abornehaute

* En conclusion le coefficient de la propension marginale a consommer est significativement différent de zéro

