 *                 CORRIGE DE L'EXERCICE CHAPITRE 2 - EXERCICE 5
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C2EX5 avant d'ouvrir le do.fileC2EX5 qui est fichier programme.
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer les calculs de l'exercice. Il sera exécuté dans son intégralité.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.

* Cet exercice fait suite à l'exercice 2 et 3 du chapitre 2. Il utilise certains des éléments de ces exercices qui dès lors ne sont pas
*recalculé

*EXERCICE : La prévision dans un modèle de régression simple

* Le calcul du coefficient de détermination. Pour calculer le coefficient on se référe à la 
*formule de l'ouvrage  où Fisher)=R2/[1-R2)/(_N-2)]=(student ta1)2. Où _N est le nombtre d'observations. 
*On utilise la formule la plus simple avec le student au carré. Le t de la régression est égal à 43.5

regress y x
gen ta1=43.54
gen F=43.54^2
display F
*F est bien supétieure au F de la table (5,32). La variable est explicative. On peut calculer le R2 et de sa valeur
gen R2=(F/(_N-2))/(1+(F/(_N-2)))
display R2

* La prévision est calculée à l'aide du modèle estimé. On calcule d'abord le revenu estimé de la 11ème période avec une augmentation de
* 800 euros. Tous les éléments nécessaires au calcul proviennent de l'exercice 2 et 3

gen y11estimé=1176.08+_b[x]*16800
display y11estimé
*On calcule l'intervalle de confiance.  = 
gen y11bas=y11estimé-2.306*143.69*sqrt((1/_N)+(16800-11280)^2/(64156000)+(1))
display y11bas
gen y11haut=y11estimé+2.306*143.69*sqrt((1/_N)+(16800-11280)^2/(64156000)+(1))
display y11haut

* De même pour la 12ème année
gen y12estimé=1176.08+_b[x]*17000
display y12estimé
*On calcule l'intervalle de confiance.  = 
gen y12bas=y12estimé-2.306*182.32
display y12bas
gen y12haut=y11estimé+2.306*182.32
display y12haut
