*CORRIGE DE L'EXERCICE CHAPITRE 5 - EXERCICE 2
*Dalila Chenaf-Nicet  Université de Bordeaux.
 
 * Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C5EX2 avant d'ouvrir le do.fileC5EX2 qui est fichier programme. 
*  Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile) pour démarrer 
 
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.

*Attention c'est le même fichier C5EX1 pour l'exercice 1 et 2
 
*         CHAPITRE 5 EXERCICE 2 
* Test d'indépendance des erreurs


* On fait la régression complète de y par rapport à x1 x2 et x3 et on récupère les résidus de la regression
regress y x1 x2 x3
predict residus, re

**********************************Première possibilité

* Etape 1 : l'estimation du rho et définition de la variable temps
tsset date
regress residus L1.residus

gen rho=_b[L1.residus]
display rho

* Etape 2 : tranformation des variables et régressions en quasi-différences
* Calcul des quasi-différences
gen dy=y-rho*L1.y
gen dx1=x1-rho*L1.x1
gen dx2=x2-rho*L1.x2
gen dx3=x3-rho*L1.x3

* Faire la régression de dy par rapport à dx1 dx2 dx3

regress dy dx1 dx2 dx3

* Calcul ldu terme constant 
gen ahat=_b[_cons]/(1- rho)
display ahat

* *******************************Deuxième possibilité

*Etape 1
* On estime rho2 à partir du DW. On fait d'abord la regression de base
regress y x1 x2 x3

* On demande le calcul de la statistique à Stata (calcul du DW fait à l'exercice C5EX1), ici c'est le calcul automatique de la statistique
* fait par stata qui est utilisé
estat dwatson
gen dw=r(dw)
display dw

*(NB : On peut en écrivant regdw y x1 x2 x3 obtenir directement la régression et la statistique)

* Faire le calcul de rho2 à partir de dw
gen rho2= 1 -(dw/2)
display rho2

* Etape 2
*Transformer les variables et régresser en quasi différences
gen dy2=y-rho2*L1.y
gen dx12=x1-rho2*L1.x1
gen dx22=x2-rho2*L1.x2
gen dx32=x3-rho2*L1.x3

* Faire la nouvelle régression
regress dy2 dx12 dx22 dx32

* Calculer le terme constant
gen ahat2=_b[_cons]/(1- rho2)
display ahat2


******************************** Estimation récursive du vecteur a et rho (méthode de Cochrane_ Orcutt)

* Estimation d'un modèle autoregressif d'ordre 1, selon la méthode
 prais y x1 x2 x3 , corc

 * On note que dans ce cas rho=0,81

 * La méthode de balayage proposé par Stata se fait avec la syntaxe
 regdw y x1 x2 x3 
 hlu y x1 x2 x3

