*CORRIGE DE L'EXERCICE CHAPITRE 7- EXERCICE 2
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C7EX2 avant d'ouvrir le do.fileC7EX2 qui est le fichier programme. 
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run 
*(Execute en haut à droite de la barre de menu du dofile) pour démarrer le programme. Il sera exécuté dans son intégralité.
   
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.

   
  *                                 CHAPITRE 7 EXERCICE 2
                        *Détermination du nombre de retards dans un modèle à retards échelonnés.

 * A chaque régression le programme donne  la valeur des critères d'information. Une fois les AIC, SC calculés. Un calcul des Fishers
 * est proposé en fin de programme.
 
 * Il n'est pas proposé le calcul des critères d'information selon la programmation Stata (avec le code estat ic après la régression)
 * car stata n'utilise pas la même méthode que l'ouvrage (passage par le maximum de vraisemblance). Dès lors pour plus de cohérence
 * avec l'ouvrage il est ici proposé un calcul pas à pas des AIC et SC comme dans l'ouvrage.
 
 */////// Le calcul des AIC , SC
 
 * On  précise  tout d'abord la variable du temps
 tsset date

 * On démarre ensuite la série des régressions pour chaque retards.
 
 *avec 0 retard
 regress y x  
 
 scalar rss0=e(rss)
 gen aic0= log(rss0/_N) +  ((2*0)/_N)
 display aic0
 scalar aic0=aic0
  gen sc0=log(rss0/_N) + (0*log(_N))/_N
 display sc0
 scalar sc0=sc0
 
 * Avec 1 retard
 regress y x L.x  
 
 scalar rss1=e(rss)
 gen aic1= log(rss1/_N) +  ((2*1)/_N)
 display aic1
  scalar aic1=aic1
  gen sc1=log(rss1/_N) + (1*log(_N))/_N
 display sc1
 scalar sc1=sc1
  
  * Avec 2 retards
 regress y x L.x L2.x 

  scalar rss2=e(rss)
 gen aic2= log(rss2/_N) +  ((2*2)/_N)
display aic2
 scalar aic2=aic2
  gen sc2=log(rss2/_N) + (2*log(_N))/_N
 display sc2
 scalar sc2=sc2
 
 * Avec 3 retards
 regress y x L.x L2.x L3.x 

  scalar rss3=e(rss)
 gen aic3= log(rss3/_N) +  ((2*3)/_N)
display aic3
 scalar aic3=aic3
  gen sc3=log(rss3/_N) + (3*log(_N))/_N
 display sc3
  scalar sc3=sc3
  
 * Avec 4 retards
 regress y x L.x L2.x L3.x L4.x 

   scalar rss4=e(rss)
 gen aic4= log(rss4/_N) +  ((2*4)/_N)
display aic4
 scalar aic4=aic4
  gen sc4=log(rss4/_N) + (4*log(_N))/_N
 display sc4
  scalar sc4=sc4
 
* Avec 5 retards 
 regress y x L.x L2.x L3.x L4.x L5.x 
 
  scalar rss5=e(rss)
 gen aic5= log(rss5/_N) +  ((2*5)/_N)
display aic5
 scalar aic5=aic5
  gen sc5=log(rss5/_N) + (5*log(_N))/_N
 display sc5
  scalar sc5=sc5
  
* Avec 6 retards  
regress y x L.x L2.x L3.x L4.x L5.x L6.x  
 scalar rss6=e(rss)
 gen aic6= log(rss6/_N) +  ((2*6)/_N)
display aic6
 scalar aic6=aic6
  gen sc6=log(rss6/_N) + (6*log(_N))/_N
 display sc6
 scalar sc6=sc6

* Avec 7 retards 
regress y x L.x L2.x L3.x L4.x L5.x L6.x L7.x 

 scalar rss7=e(rss)
 gen aic7= log(rss7/_N) +  ((2*7)/_N)
display aic7
 scalar aic7=aic7
  gen sc7=log(rss7/_N) + (7*log(_N))/_N
 display sc7
  scalar sc7=sc7
   
* Avec 8 retards
regress y x L.x L2.x L3.x L4.x L5.x L6.x L7.x L8.x 
 
  scalar rss8=e(rss)
 gen aic8= log(rss8/_N) +  ((2*8)/_N)
display aic8
 scalar aic8=aic8
  gen sc8=log(rss8/_N) + (8*log(_N))/_N
 display sc8
  scalar sc8=sc8
  
* Avec 9 retards
 regress y x L.x L2.x L3.x L4.x L5.x L6.x L7.x L8.x L9.x  
   
  scalar rss9=e(rss)
 gen aic9= log(rss9/_N) +  ((2*9)/_N)
display aic9
 scalar aic9=aic9
  gen sc9=log(rss9/_N) + (9*log(_N))/_N
 display sc9
  scalar sc9=sc9
 
 * Avec 10 retards
 regress y x L.x L2.x L3.x L4.x L5.x L6.x L7.x L8.x L9.x L10.x  in 11/44

scalar rss10=e(rss)
 gen aic10= log(rss10/_N) +  ((2*10)/_N)
display aic10
 scalar aic10=aic10
  gen sc10=log(rss10/_N) + (10*log(_N))/_N
 display sc10
  scalar sc10=sc10

 * Il est possible de proposer un tableau récapitulatif des résultats de AIC et SC

 matrix AIC=[aic0\aic2\aic3\aic4\aic5\aic6\aic7\aic8\aic9\aic10]

 matrix BIC=[sc0\sc2\sc3\sc4\sc5\sc6\sc7\sc8\sc9\sc10]
 
 
 matrix  Critère=[AIC,BIC]
 matlist Critère
 
 * On peut pointer 6 retards comme étant le minimum des retards.
 
 
 * ****************************Le calcul des Fishers. 
 * Il faut à chaque fois faire les tests mais avec le même nombre d'observations. Donc il faut supprimer les 10 premières observations 
 * de l'échantillon et faire les régressions de la 11 à la 44 donnée. 
 * Chaque fois il faut récupérer la somme des carrés des résidus (rss) pour effectuer le test de Fisher
 
 * Avec 0 retard
 regress y x  in 11/44
 scalar SCR0=e(rss)

 
 * Avec 1 retard 
 regress y x L.x  in 11/44
  scalar SCR1=e(rss)
 
   scalar F1= (SCR0-SCR1)/(SCR1/(34-10+10-3))
  display F1
 
  
  * Avec 2 retards
 regress y x L.x L2.x  in  11/44
  scalar SCR2=e(rss)
 
  scalar F2= (SCR1-SCR2)/(SCR2/(34-10+9-3))
  display F2
 
 * Avec 3 retards
 regress y x L.x L2.x L3.x in 11/44
scalar SCR3=e(rss)
 
  scalar F3= (SCR2-SCR3)/(SCR3/(34-10+8-3))
  display F3
  
   * Avec 4 retards
 regress y x L.x L2.x L3.x L4.x in 11/44
  scalar SCR4=e(rss)
 
   scalar F4= (SCR3-SCR4)/(SCR4/(34-10+7-3))
  display F4
  
*  Avec 5 retards 
 regress y x L.x L2.x L3.x L4.x L5.x in 11/44
 scalar SCR5=e(rss)

 scalar F5= (SCR4-SCR5)/(SCR5/(34-10+6-3))
  display F5
 
* Avec 6 retards  
regress y x L.x L2.x L3.x L4.x L5.x L6.x  in 11/44
 scalar SCR6=e(rss)
  scalar F6= (SCR5-SCR6)/(SCR6/(34-10+5-3))
  display F6

* Avec 7 retards 
regress y x L.x L2.x L3.x L4.x L5.x L6.x L7.x in 11/44

 scalar SCR7=e(rss)
 scalar F7= (SCR6-SCR7)/(SCR7/(34-10+4-3))
  display F7
 
* Avec 8 retards
regress y x L.x L2.x L3.x L4.x L5.x L6.x L7.x L8.x in 11/44
  scalar SCR8=e(rss)
 scalar F8= (SCR7-SCR8)/(SCR8/(34-10+3-3))
  display F8
  
* Avec 9 retards
 regress y x L.x L2.x L3.x L4.x L5.x L6.x L7.x L8.x L9.x  in 11/44
  scalar SCR9=e(rss)
 scalar F9= (SCR8-SCR9)/(SCR9/(34-10+2-3))
  display F9
 
 * Avec 10 retards
  regress y x L.x L2.x L3.x L4.x L5.x L6.x L7.x L8.x L9.x L10.x  in 11/44

   scalar SCR10=e(rss)
 scalar F10= (SCR9-SCR10)/(SCR10/(34-10+1-3))
  display F10
 
 * On peut faire un récapitulatif des résultats des test de Fisher
  
 matrix F=[F1\F2\F3\F4\F5\F6\F7\F8\F9\F10]
 matlist F

 * Pour une synthèse des critères  AIC , SC et F
 matrix Synthèse=[Critère, F]
 matlist Synthèse

 
 * On retient donc 6 retards.
 
 */// L'analyse se poursuit avec la régression avec 6 retards où les coefficients estimés seront analysés
 
regress y x L.x L2.x L3.x L4.x L5.x L6.x 
scalar coef0=_b[x]
scalar coef1=_b[L.x]
scalar coef2=_b[L2.x]
scalar coef3=_b[L3.x]
scalar coef4=_b[L4.x]
scalar coef5=_b[L5.x]
scalar coef6=_b[L6.x]

*Le tableau des coefficients est donné par :

matrix COEF=[coef0\coef1\coef2\coef3\coef4\coef5\coef6]
matlist COEF

svmat COEF

* Le graphique illustre la structure de pondération de retards pour le modèle 6 estimé

twoway (line  COEF date if date <10)

* Le retard moyen est égal à :

gen D = (coef1+2*coef2+3*coef3+4*coef4+5*coef5+6*coef6)/(coef0+coef1+coef2+coef3+coef4+coef5+coef6)
display D

* Le délai moyen de réaction est 3.64 trimestres, soit presque une année.
