*CORRIGE DE L'EXERCICE CHAPITRE 7- EXERCICE 8
*Dalila Chenaf-Nicet  Université de Bordeaux.
         
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C7EX8 avant d'ouvrir le do.fileC7EX8 qui est le fichier programme. 
   
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run 
*(Execute en haut à droite de la barre de menu du dofile) pour démarrer le programme. Il sera exécuté dans son intégralité.

 
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.
  
                                          * CHAPITRE 7 EXERCICE 8
* Un comparaison des courbes de Phillips française et américaine

* Il faut définir la variable du temps
 tsset Année
 
* Il faut créer les variables retardées. Sous stata pour indiquer dans une commande qu'une variable est retardée cela s'écrit 
* simplement L.x dans la ligne de programme.  
* Cependant quand il est nécessaire de récupérer des statistiques sur une variables retardées (coefficients estimés,  * DW, etc.) 
* stata ne les reconnait pas forcément. Il faut  créer en tant que telle la variable L.x. 
 *Il faut donc systématiquement créer la variable avant les estimations où la récupération de statistique est nécessaire
  gen Lchousa=L.chousa
  gen Lchofra=L.chofra
  gen Linffra=L.inffra
  gen Linfusa=L.infusa
  
* Les représentations graphiques des courbes
 
 twoway ( line  inffra chofra )
  twoway ( line  infusa chousa )
  
  *Les estimations économétriques
  
 *////// * Pour la France
 * Avec un retard
  regdw inffra Lchofra
* On récupère les résidus de cette relation
predict residufra, re

* Sans retard
  regdw inffra chofra
  
  *///// Pour les USA
  * avec un retard
  regdw infusa Lchousa
  * On récupère les résidus de cette relation
   predict residuusa, re
   
* Sans retard
  regdw infusa chousa
  
  * Les graphes des résidus sont donnés par : 
  
  twoway (tsline  residufra)
   twoway (tsline  residuusa)
   
* Nous faisons à présent le test d'autocorrélations des erreurs
    
*// Pour la France la Statistique du DW dans le modèle avec retard est DW=0.23
* Etant données la valeurs de la table on peut conclure qu'il y a de l'autocorrélation positive des erreurs
	
* Il est également possible pour la France de faire le test de Breusch-Godfrey
	
reg inffra Lchofra

 estat bgodfrey 
	 
* Or selon la statistique du Khi 2, on rejette HO (hypothèse H0 :no serial correlation), on accepte l'hypothèse H1 de corrélation. 

*// Pour les USA la statistique du DW dans le modèle avec retard est DW=0.42
* Etant donnée la valeur de la table on peut conclure qu'il y a de l'autocorrélation positive des erreurs.
*  Il est également possible pour les USA de faire le test de Breusch-Godfrey

reg infusa Lchousa
	 estat bgodfrey 
 * Or selon la statistique du Khi 2, on rejette HO (hypothèse H0 :no serial correlation), on accepte l'hypothèse H1 de corrélation. 

* Il faut à présent construire une variable DUM
 gen DUM= 0
 replace DUM = 1 in 11
  replace DUM = 1 in 17
  
* Estimation de la courbe de Philip sans autocorrélation des résidus pour la France 
  
  regdw inffra chofra Lchofra
  
* Les deux variables ont des coefficients qui ne sont pas significativement différents de zéro.

* Estimation de la courbe de Philip sans autocorrélation des résidus pour  les USA
 
  regdw infusa chousa Lchousa
  
* En ce qui concerne les Etat-Unis le modèle semble mieux adapté.
  
* Estimation d'un nouveau modèle qui introduit la variable muette DUM
  
  */// Pour la France
  
reg inffra L.inffra chofra L.chofra DUM
durbinh

 */// Pour les USA
  reg infusa L.infusa chousa L.chousa DUM
  durbinh
  
* Le test de Chow
  
* Il est à effectuer à la période 20 comme période charnière. 
 * Comme pour la deuxième période la variable DUM est égale à 0 (colinéarité avec le terme contant), nous la retirons de l'estimation
 
 * ///Pour la France
reg inffra L.inffra chofra L.chofra 
 scalar rss=e(rss)

 reg inffra L.inffra chofra L.chofra if Année <21
 scalar rss1=e(rss)
 
  reg inffra L.inffra chofra L.chofra if Année >20
 scalar rss2=e(rss)
 
 * Il faut sous stata faire le calcul de F qui n'est pas donné automatiquement
 
 gen  F1france=  ((rss - (rss1+rss2))/4)/((rss1+rss2)/(33-2*4))
 display F1france
       
	   
 * ///Pour les USA
reg infusa L.infusa chousa L.chousa 
 scalar rssusa=e(rss)

 reg infusa L.infusa chousa L.chousa if Année <21
 scalar rss1usa=e(rss)
 
  reg infusa L.infusa chousa L.chousa if Année >20
 scalar rss2usa=e(rss)
 
 * Il faut sous stata faire le calcul de F qui n'est pas donné automatiquement
 
 gen  F1usa=  ((rssusa - (rss1usa+rss2usa))/4)/((rss1usa+rss2usa)/(33-2*4))
 display F1usa

 * Il faut refaire le test pour les Etats-unis avec un breakpoint à 18
 
 reg infusa L.infusa chousa L.chousa 
 scalar rssusa18=e(rss)

 reg infusa L.infusa chousa L.chousa if Année <19
 scalar rss1usa18=e(rss)
 
  reg infusa L.infusa chousa L.chousa if Année >18
 scalar rss2usa18=e(rss)
 
 * Le calcul de F :
 
 gen  F1usa18=  ((rssusa18 - (rss1usa18+rss2usa18))/4)/((rss1usa18+rss2usa18)/(33-2*4))
 display F1usa18
