*CORRIGE DE L'EXERCICE CHAPITRE 10- EXERCICE 2
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C10EX2 avant d'ouvrir le do.fileC10EX2 qui est le fichier programme. 
  
 *  Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run  (Execute en haut à droite de la barre de menu du dofile)
 * pour démarrer le programme. Il sera exécuté dans son intégralité.

 * Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.
  
 
 *                                   CHAPITRE 10 EXERCICE 2
                                     * Spécification, estimation et prévision d'un modèle var
 
 * Nous avons des données trimestrielles CVS et en différences premières sur 18 ans 
 gen trimestres=(_n)
 tsset trimestres
 
 * On recherche l'ordre du VAR en utilisant AIC / BIC. Stata donne directement le retard optimal avec le code varsoc en utilisant 
 * au maximum 9 décalages
 
 varsoc y1 y2, maxlag(8) lutstats  
 
 * La procédure varsoc qui utilise AIC, BIC, HQIC indique systèmatiquement 1 retard (étoile).
 
 * Estimation des paramètres dans le cadre d'un var1, il n'est pas utile ici de faire chaque régression (MCO)séparement.
 * Il suffit sous stata d'utiliser le code "var" comme ci après.

 var y1 y2, lag(1)
 
* On peut récupérer les résidus ainsi que la matrice des variances co-variances des résidus

matrix E=e(Sigma)
mat list E

*On calcule le déterminant de E
scalar dete=det(E)
display dete

* On peut calculer AIC 
gen aic1=log(dete)+ (2*2^2*1)/_N
display aic1

* On peut calculer BIC 
gen bic1=log(dete)+ (2^2*1*log(_N))/_N
display bic1

* Si on refait l'opération pour différents retards p=2, p=3, P=4, on observe que 1 retard minimise bien le critère

****Atention le code Stata de var y1 y2, donne directement les AIC, BIC, HBIC sans besoin de faire les calculs. 
* Les résultats donnés par stata sont toutefois différents du mode de calcul du livre car la formule utilisée par Stata est  différente.
*  Cependant, les conclusions des tests sont identiques

* La prévision

 var y1 y2 if trimestre <=73, lags(1) 
fcast compute var1, step(4)


* La prévision est faite sur la dernière estimation VAR qui est ici nommée var1 (on lui donne le nom que l'on veut)

* Attention Stata donne les résultats de la prévision mais tout en en bas du fichier de données ( ouvrir Data Editor et regarder au niveau
* des dernières lignes du fichier). Il y est donné la valeur prévue de y1 et y2 sur 4 périodes (noté var1y1 et vary2, est également donné les 
* intervalles de confiance avec LB la borne basse (L pour low) et UB la borne suppérieure (U pour upper). Sont aussi donnés les écarts types
