*CORRIGE DE L'EXERCICE CHAPITRE 11-EXERCICE 2
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C11EX2 avant d'ouvrir le do.fileC11EX2 qui est le fichier programme. 
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run  (Execute en haut à droite de la barre de menu du dofile)
*pour démarrer le programme. Il sera exécuté dans son intégralité.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.
  
 
 *                 CHAPITRE 11 EXERCICE 2

                  * Test de cointégration et et estimation d'un VEC
 * Il faut définir la variable du temps
 gen temps=(_n)
 tsset temps

 * Une représentaion graphique des données nous donne : 
 
 twoway (tsline y1 y2 y3)
 
 * //////Le test de longueur de retard est proposé dans l'étape 2
 
varsoc y1 y2 y3, lutstat

* Dans la mesure où 2 des 4 critères pointent 2 retards et que le nombre d'observations est faible nous utiliserons 2 retatrds.
* Nous allons donc procéder au test de Johansen sur un VECM(1)

*////// Etape 2 on procéde au test de Johansen

*   - Existence d'une constante dans la relation de long terme  et pas dans les données (pas de tendance déterminsite), spécification b

vec y1 y2 y3
vecstable, graph
vecrank y1 y2 y3 , trend(rconstant)

* Les trois valeurs propres de la matrice Pi estimées par le maximum de vraisemblance sont égales à alpha1=0.60, alpha 2=0.23 et alpha3=0.13.
* Pour 0 relation de cointégration le test de trace 38,5 (5%), est supérieur à la valeur critique de 34.91
* Nous rejetons l'hypothèse.

*Pour un relation le test de trace est de 12.50 < à la valeur critique de 19.96, nous acceptons l'hypothèse d'une relation 
* de cointégration. 
* Le test indique qu'il n'y en a pas 2 . 
* On notera que Stata met une étoile dans la ligne du "bon nombre de relations de cointégration. Ce qui est pratique !

*   - Existence d'une constante dans la relation de long terme  et dans les données, spécification c

vec y1 y2 y3
vecstable, graph
vecrank y1 y2 y3 

* Les trois valeurs propres de la matrice Pi estimées par le maximum de vraisemblance sont égales à alpha1=0.60 , alpha 2=0.23 et alpha3=0.13.
* Pour 0 relation de cointégration le test de trace 37,38 (5%), est supérieur à la valeur critique de 29.68.
* Nous rejetons l'hypothèse
* Pour un relation le test de trace est de 11,46 < à la valeur critique de 15,41, nous acceptons l'hypothèse d'une relation 
* de cointégration. 
* Le test indique qu'il n'y en a pas 2.

* On peut faire à présent le test de la valeur propre maximum
vec y1 y2 y3
vecstable, graph
vecrank y1 y2 y3, max levela notrace


* L'hypothèse d'une relation de cointégration est vérifiée. On estime donc le VEC

vec y1 y2 y3
vecstable, graph
vecrank y1 y2 y3, max levela notrace 

* Le test des valeurs propres maximales corroborent le résultat

* L'étoile indique le rejet de l'hypothèse (On rejet 0 relation contre 1 relation, On accepte 1 contre 2, on rejete 2 contre 1)

* Quatrième étape 

vec  y1 y2 y3, rank(1) 
vecstable, graph
