*CORRIGE DE L'EXERCICE CHAPITRE 12-EXERCICE 3
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C12EX3 avant d'ouvrir le do.fileC12EX3 qui est le fichier programme. 
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer le programme. Il sera exécuté dans son intégralité.
 
 * Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.
  
 
 *                                   CHAPITRE 12 EXERCICE 3
                                     * Prévision de la demande d'électricité pour un fournisseur à capacité limité
									 								 
* 1 - L'estimation Tobit 
*Estimer le modèle Logit permettant de prévoir la demande quotidienne à partir des facteurs explicatifs. La commande est censurée par 
* les valeur [0 ; 3000].
tobit y x1 x2 x3, ll(0) ul(3000)

* Les coefficients sont tous significativement différents de zéro. Le modèle est sur le plan statistique validé.
* Stata indique sous le tableau de résultats le nombre de données censurées 0 a gauche et 8 à droite.

* Les variables ont bien le signe attendu le modèle est validé sur le plan empirique.
* Le modèle Tobit s'écrit 
* y = - 27.69x1 + 20.50*x2 + 186.23*x3+1473.64

* On peut faire le graphe de la série ajustées et de la série brute
predict yajusté, xb
gen temps=[_n]
tsset temps

twoway (tsline yajusté y) 

* 2 l'application des MCO

regress y x1 x2 x3
predict ymco, xb

* Les coefficients du modèle tous significativement différents de 0 sont biaisés.

twoway (tsline ymco y) 

* Le calcule de la prévision
* Sachant que x1,61= 1 ; x2,61 = 98 et x3,61=1
* Sachant que x1,62= 0 ; x2,61 = 60 et x3,61=0

*La prévision pour le jour 61 est données par :

gen y61= - 27.69*1 + 20.50*98 + 186.23*1+1473.64
display y61

*La prévision pour le jour 62 est données par :

gen y62= - 27.69*0 + 20.50*60 + 186.23*0+1473.64
display y62
