*CORRIGE DE L'EXERCICE CHAPITRE 13- EXERCICE 2
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
  * Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C13EX2
  * avant d'ouvrir le do.fileC13EX2 qui est le fichier programme. 
  
 *  Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run 
  *(Execute en haut à droite de la barre de menu du dofile) pour démarrer le programme. Il sera exécuté dans son intégralité.
* Tputefois il est possible en sélectionnant les étapes du programme de l'exécuter pas à pas afin de voir apparaître pas à 
*pas les différents résultats.

  
 
 * CHAPITRE 13 EXERCICE  2
 *Estimation des modèles à effets fixes individuels, aléatoires, estimateurs Between TEst d'Hausman
 
 
 * Dans le fichier joint les 9 dummy sont déjà crée. Cependant pour créer une dummy sous stata vous
 *pouvez utiliser le programme suivant qui créer une variable binaire 1, le pays est le pays 1, 0 sinon
 
 gen dummy=0
 replace dummy=1 if pays==1
 
 * cette variable dummy qui sert n'example n'est pas utile par la suite puisque toutes les 
 * variables muettes sont créées. Il faut donc l'effacer
 drop dummy
 
 * Première Etape nous procédons à l'estimation MCO sur données empilées mais nous introduisons
 * les dummies
 tsset pays Année

 
 regress y x1 x2 dum1 dum2 dum3 dum4 dum5 dum6 dum7 dum8 dum9, noconstant
 
 * Il faut récupérer l'ensemble des coefficients des constantes aoi
 
scalar ao1=_b[dum1]
 scalar ao2=_b[dum2]
 scalar ao3=_b[dum3]
 scalar ao4=_b[dum4]
 scalar ao5=_b[dum5]
 scalar ao6=_b[dum6]
 scalar ao7=_b[dum7]
 scalar ao8=_b[dum8]
 scalar ao9=_b[dum9]

gen moyenneao=(ao1+ao2+ao3+ao4+ao5+ao6+ao7+ao8+ao9)/9
display moyenneao

gen AOI=ao1 in 1/10
replace AOI=ao2 in 2
replace AOI=ao3 in 3
replace AOI=ao4 in 4
replace AOI=ao5 in 5
replace AOI=ao6 in 6
replace AOI=ao7 in 7
replace AOI=ao8 in 8
replace AOI=ao9 in 9
replace AOI= moyenneao in 10


* On calcule à présent les ai = (aoi - moyenneaO)

gen  ai=AOI-moyenneao


mkmat AOI ai, mat(résultats)
mat list résultats 

* Nous retrouvons la valeurs des effets fixes (cross) que nous avions obtenus en faisant le modèle à 
* effets fixes de l'exercice 1 du chapitre 13.

* 2) L'estimation du modèle à effets aléatoires

xtreg y x1 x2, re
predict re, u
*On peut aussi les afficher à l'écran
scalar _1_C= re in 1
scalar _2_C= re in 26
scalar _3_C= re in 51
scalar _4_C= re in 76
scalar _5_C= re in 101
scalar _6_C= re in 126
scalar _7_C= re in 151
scalar _8_C= re in 177
scalar _9_C= re in 202
display _1_C
display _2_C
display _3_C
display _4_C
display _5_C
display _6_C
display _7_C
display _8_C
display _9_C

* Nous observons que le modèle re conduit à des estsimations des coefficients très différents 
* du modèle fe

* L'estimation between 
sort pays
bysort pays : summarize y x1 x2

* On obtient ainsi la liste des moyennes pays variable et par pays.

xtreg y x1 x2, be

xtreg y x1 x2,fe
est store fe
xtreg y x1 x2,re
hausman fe

* Nous obtenons 8.88 > au Khi2 de la table. Nous rejetons HO. Le modèle est a effets fixes individuels
