*                 CORRIGE DE L'EXERCICE CHAPITRE 3 - EXERCICE 6 
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C3EX6
* avant d'ouvrir le do.fileC3EX6 qui est fichier programme.
*  Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run *(Execute en haut à droite de la barre de menu du dofile) pour démarrer.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.                   
            

                                *CHAPITRE 3  EXERCICE 6 
								* Etude de la saisonnalité par variable indicatrice
								
*Le fichier de données présente une variable "date" non numérique. Elle permet de représenter les 4 trimestres de 5 années.
* Soit 20 périodes (n) d'observations. Il faut donc créer une variable "temps' que Stata puisse reconnaitre comme étant une variable numérique du temps

gen temps=_n

* Il faut ensuite indiquer à stata que cette nouvelle variable est la variable du temps qui passe.
tsset temps

* Question 1 : On doit réaliser l'estimation du modèle de régression simple entre les ventes notées 'ventes' et les dépenses de publicités notées 'Pub' dans le fichier.

regress ventes pub

* On note que pour un échantillon de n=20 observations, le R2 est de 0,16 (ce qui reste faible. 
*A la question la publicité a t-elle un effet significatif sur les ventes on note que la valeur du ratio du student empirique permet de répondre que non.
*t*=1,85 <t tabulé=2,10. Le coefficient a1 n'est pas significativement différent de zéro.

*Question 2 :faire le graphique de la série des ventes et des dépenses publicitaires en fonctions du temps (tsline)

twoway tsline  pub ventes , xtitle(trimestres) ytitle(ventes-publicités)

* On note une forte composante saisonnière avec un creux prononcé au troisième trimestre.
* La variable de dépenses de publicité indique un trend haussier mais n'est pas affectée de mouvement saisonnier.

*Question 3 : Il faut créer un variable trimestre qui repére les 4 trimestres des 5 années. Puis 4 variables muettes (Di)
* Di prend la valeur 1 quand nous sommes sur le trimestre i (i=1,..,4) sinon 0

egen trimestre=group(date)
gen D1=0
replace D1=1 if trimestre==1
gen D2=0
replace D2=1 if trimestre==2
gen D3=0
replace D3=1 if trimestre==3
gen D4=0
replace D4=1 if trimestre==4

* Le tableau des variables avec les variables indicatrices est donné par :

mkmat ventes pub D1 D2 D3 D4, mat(tableau8)
mat list tableau8

*faire la régression en tenant compte des 3 variables dichotomiques  D1, D2,D3(ne pas inclure la quatrième en raison de problème de colinéarité.

regress ventes pub D1 D2 D3

* Le R2=0.83 augmente fortement, et les dépenses publicitaires dont le ratio de student est égal à 3.97 sont maintenant explicatives des ventes.
* La variable indicatrice D3 à un coefficient significatif et positif.

