*  CORRIGE DE L'EXERCICE CHAPITRE 3 - EXERCICE 8 
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C3EX8 avant d'ouvrir le do.fileC3EX8 qui est fichier programme. 
* Attention c'est bien le fichier Excel de l'exercice 1 qui est ici réutilisé.

*  Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats. 
                     

                                *  CHAPITRE 3  EXERCICE 8
								
								* Test de stabilité structurelle . Test de spécification de Ramsey
								
*On va provéder à l'estimation des coefficients a0 (constante) a1 a2 et a3 sur 7, 8, ..14 observations. 
* Avec le logociel Stata on ne peut démarrer avec moins de 7 points de données car en dessous il n'y a pas assez de dégrés de liberté.
*Soit 8 coefficients différents par variable explicative. 

*1ere estimation qui va de la 1ère période à la 7ème période 
regress y x1 x2 in 1/7
estimate store modèle1

* 2ème estimation

regress y x1 x2 in 1/8
estimate store modèle2

* 3ème estimation

regress y x1 x2 in 1/9
estimate store modèle3

*4ème estimation

regress y x1 x2 in 1/10
estimate store modèle4

*5ème estimation

regress y x1 x2 in 1/11
estimate store modèle5

*6ème estimation

regress y x1 x2  in 1/12
estimate store modèle6

* 7ème estimation

regress y x1 x2 in 1/13
estimate store modèle7

*8ème  estimation

regress y x1 x2  in 1/14
estimate store modèle8

* On peut faire à présent les qraphiques des coefficients avec les intervalles de confiances.

coefplot (modèle1,label(7 observations)) (modèle2, label(8 observations)) (modèle3, label(9 observations)) (modèle4, label(10 observations))(modèle5, label(11 observations))(modèle6, label(12 observations)) (modèle7, label(13 observations))(modèle8, label(14 observations)),  xtitle("périodes") vertical bycoefs byopts(yrescale)

*On constate que les coefficients restent toujours dans leur intervalle de confiance. On peut rejetter l'hypothèse d'un changement structurel


* Calculer le cusum et le cusumSQ. Mais il faut au préalable créer (gen) une variable qui représente les périodes (temps) car le cusum ne s'appliquent au séries temporelles. 
* Et il faut préciser à Stata qu'elle est la variable qui représente le temps notée "temps) ( code : tsset)

gen temps=(_n)
tsset temps

*On peut à présent appliquer le test à la relation (attention sous certaines versions de stata il faut télécharger le package du cusum qui se nomme cusum6

regress y x1 x2
cusum6  y x1 x2 

* Hormis à la période 9 du test Cusum où il y a un léger franchissement de l'intervalle, on accepte l'hypothèse de stabilité des coefficients.


*On peut de même faire un test de Ramsey.On a ici deux possibilités : 
*					-  On peut soit le construite
* Construire le test en faisant les deux régressions et en utilisant les y estimés au carré

regress y x1 x2
predict xb
gen yestimé=xb
gen ysquare =yestimé^2
regress y x1 x2 ysquare

* on note que le t student de ysquare est égale à t=0, 223 et donc t2=F=0,0498. On accepte donc H0

	*               - Peut aussi en deuxième possibilité utiliser directement une commande sous Stata qui calcule le test de Ramsey de RESET
regress y x1 x2
ovtest, rh

* Il y a 76% de rejeter à tort H0. L'hypothèse H0 est donc accéptée. Le modèle est donc correstement spécifié.

