*  CORRIGE DE L'EXERCICE CHAPITRE 4 - EXERCICE 1 
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C4EX1 avant d'ouvrir le do.fileC4EX1 qui est fichier programme. 

*  Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer.
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.             

                                * CHAPITRE 4  EXERCICE1 
						*Calcul des coefficients de corrélation partielle du 1er et 2ème ordre.
* Sont ici traités les calculs complets ded coefficients de corréglation simpl et partielles
* Calcul de r2(y x1, x2) et de r2(y x3.x1, x2).

* *************************************Le cacul de r2(y x1, x2) 
*Etape 1
regress y x2
predict residuals1, re

* Etape 2
regress x1 x2
predict residuals2, re

*Etape 3 récupération des résidus des deux régressions puis calculer les coefficients
mkmat residuals1 residuals2, mat(résidus)
mat list résidus

correlate residuals1 residuals2

* La corrélation entre les ventes et la publicité est donc de 0,46, lorsque l'influence de la promotion auprès des 
* distributeurs est retirée.

****************************************** Le cacul de  r2(y x3.x1, x2)
*Etape 1
regress y x1 x2
predict residuals11, re
*Etape 2
regress x3 x1 x2
predict residuals21,re
*Etape 3

mkmat residuals11 residuals21, mat(residusmodèle2)
mat list residusmodèle2

correlate residuals11 residuals21

* La corrélation entre les ventes et la promotion "consommateur" est donc égale à 0,84, lorsque les influences
* de la publicité et de la promotion sont retirées.

* Calcul à parir du t de Student. Stata ne donne pas directement la valeur du t il faut la reconstituer en faisant 
* le rapport du coefficient estimé àl'écart-type
regress y x1 x2 x3
scalar t =_b[x3]/_se[x3]
display t

*On peut ensuite calculer le r2(y x3.x1, x2) avec la formule
 scalar r2=(t^2)/(t^2 +(_N-3 -1))
 display r2

*On retrouve la valeur de 0,848.

* Mais il existe une commande sous Stata qui permet de calculer facilement toutes les corrélations partielles
pcorr y x1 x2 
pcorr y x1 x3
pcorr y x2 x3
pcorr y x1 x2 x3

*Les colonnes Partial corr.¨^2 donnent l'ensemble des résultats possibles.




