*  CORRIGE DE L'EXERCICE CHAPITRE 4 - EXERCICE 4
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C4EX4 avant d'ouvrir le do.fileC4EX4 qui est fichier programme. 

*  Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run *(Execute en haut à droite de la barre de menu du dofile)
* pour démarrer .
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.               

                                * CHAPITRE 4 EXERCICE 4
								
* Il faut tout d'abord faire la régression 
regress y x1 x2 x3 

* Obtenir la matrice des corrélations simples (avec seuil de significativité à 5%)

pwcorr y x1 x2 x3 x4, sig star(5)

* A la lecture de ces coefficients il ne semble pas y avoir de risques éléves de  multicolinéarité puisque les coefficients de corrélation
* simple sont inférieurs au R2= 0.998.Cependant la valeur du R2 est très élevée. Il y a donc place au doute.


* Test de Farrar-Glauber pas à pas. La matrice des corrélations 
pwcorr x1 x2 x3 x4
 matrix R=r(C)
 mat list R
 
 * Le calcul du déterminant
 
matrix DR=det(R)
mat list DR

* Calcul de la valeur empirique du X2
svmat DR
scalar XI2= -[_N-1 -1/6 *(2*5+5)]*log(DR)
display XI2

* Comme le Khi2 calculé (76,96) est supérieur au Khi2 de la table alors nous rejetons HO il y a présomption de multicolinéartité.

* Il est possible de faire simplement sous Stata le test de Farrar - Glauber. Qui est un test de Khi2

fgtest y x1 x2 x3 x4

* Nous rejetons HO, il y a présomption de multicolinéarité.
