*  CORRIGE DE L'EXERCICE CHAPITRE 4 - EXERCICE 5
*Dalila Chenaf-Nicet  Université de Bordeaux.

* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C4EX5 avant d'ouvrir le do.fileC4EX5qui est fichier programme. 

* Attention Pour l'exercice 5 il est également utilisé le fichier Excel de données C4EX4.

*  Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
*  pour démarrer.

* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.  
        
                                *CHAPITRE 4 EXERCICE 5 
								* Méthide de sélection de variables explicatives
								
* 1ere méthode (un peu longue...) 

*Il s'agit de réaliser les 15 équations proposant les 15 combinaisons possibles avec les vatiables x1, x2, x3 et x4 pour choisir 
* la meilleur estimation en fonction des critères d'information (Akaiké, Schwartz). 
* A chaque fois après la régression, il faut demander les valeurs des critères ( avec le  code "esta ic").

*Les équations à 1 variable
regres y x1
estat ic

regres y x2
estat ic

regres y x3
estat ic

regres y x4
estat ic

*Les équations à 2 variables avec x1
regres y x1 x2
estat ic

regres y x1 x3
estat ic

regres y x1 x4
estat ic

*Les équations à 2 variables avec x2
regres y x2 x3
estat ic

regres y x2 x4
estat ic
* Les équations à 2 variables avec x3
regres y x3 x4
estat ic

*Les équations à 3 variables 
regres y x1 x2 x3
estat ic
regres y x1 x4 x3
estat ic
regres y x1 x2 x4
estat ic
regress y x2 x3 x4
estat ic

* Un fois les estimations réalisées on constate qu'il faut éliminer celles dont un ou plusieurs ratios de Student sont inféreurs 
* au seuil critique (t=2.30). 

*On peut donc conserver les modèles M1, M2, M3 M4, M9 et M13.

*Parmi les 6 équations restantes on sélectionne celles dont le critère de Akaiké/Schartz est le plus faible.
* Il s'agit du modèle M13 avec x1, X4 et X3 comme variables explicatives.

*2ème méthode : la sélection progressive.

*On cacule les coefficients de corrélation simple entre les variables et on prend la variable qui a le coefficient le plus élevé 
* et significatif au seuil de 5%.

pwcorr y x1 x2 x3 x4, sig star(5)

*Il apparait que x1 a le coefficient le plus élevé. Donc on fait 3 estimations :

* x1 et x2 ; x1 et x3; x1 et x4
regress y x1 x2
regress y x1 x3
regress y x1 x4

*Dans les trois modèles la nouvelle variable explicative n'est jamais significative. On garde le modèle avec juste x1 (M1)

* 3ème méthode : La régression pas à pas.

* Dans le cas présent elle est identique à la précédente, puisque on doit commencer avec 1 variable, puis 2, puis 3.
*Mais ici après x1 plus aucune variable n'est significative.

* 4ème méthode : La régression par étage.

*On cacule les coefficients de corrélation simple entre les variables et on prend la variables qui à le coefficient
*le plus élevé (et significatif au seuil de 5%!) c'est à dire une fois de plus x1. 
* On réalise la régression et on récupère les résidus de la régression notés "e1".

regress y x1
predict e1, re
mkmat e1, mat(résidus)
mat list résidus

* Calculer les coefficients de corrélation simple entre les résidus et les variables : e1 et x2, e1 et x3 et e1 et x4.
* Le coefficient de corrélation entre e1 et x1 est forcément nul. 

pwcorr e1 x2 x3 x4, sig star(5)

*Les autres coefficients ne sont pas significativement différents de zéro, la procédure s'arrête.
