*CORRIGE DE L'EXERCICE CHAPITRE 5 - EXERCICE 5
*Dalila Chenaf-Nicet  Université de Bordeaux.
 
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C5EX5 avant d'ouvrir le do.fileC5EX5 qui est fichier programme. 

* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile) 
* pour démarrer 
 
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.
     
*                                     CHAPITRE 5 EXERCICE 5

* Test d'exogénéité d'Hausman, modèle sur les variables: techniques des variables instrumentales

* Tout d'abord créer les matrices nécessaires au calcul des coefficents notés avi(coefficient des variables instrumentales) 
* et amco (coefficients des MCO)

* Il faut créer la colonne de la constante bz pour la matrice Z et bx pour la matrice des x

gen bz= 1
mkmat bz z, mat(Z)

gen bx= 1
mkmat bx x, mat(X)

mkmat y, mat(Y)

* Le calcul de amco
matrix amco=inv(X'*X)*X'*Y
matlist amco

* Le calcul de avi
matrix avi=inv(Z'*X)*Z'*Y
matlist avi

* On peut calculer la variance de amco. On récupère ensuite les résidus 
matrix emco=Y-X*amco
matlist emco
matrix variancerésidu= (1/18)*(emco'*emco)
matlist variancerésidu
 matrix varcovarmco= variancerésidu*(inv(X'*X))
 matlist varcovarmco
 
 * On peut calculer la variance de avi. On récupère les résidus de la relation
 matrix evi=Y-X*avi
matlist evi
matrix variancerésiduvi= (1/18)*(evi'*evi)
matlist variancerésiduvi

 matrix varcovarvi= variancerésiduvi*inv(Z'*X)*(Z'*Z)*inv(X'*Z)
 matlist varcovarvi
 
 * On peut calculer la statistique de H
 
 matrix H= (avi-amco)'*inv(varcovarvi-varcovarmco)*(avi-amco)
 matlist H
 
* On note que 7,63 est supérieur au Khi2 de la table au seuil de 5% (Khi de de la table = 5.99). 
* Nous rejetons l'hypothèse HO, l'estimateur MCO est biaisé et il convient d'utiliser avi coomme estimateur. 

*****************************************************1ere Etape
* Il s'agit à présent de faire une régression augmentée.  Nous procédons au test d'hausman en quatre étapes.

* Nous estimons par les MCO la régression de x par rapport à l'instrument Z
regress x z

* Nous récupérons alors les x estimés par la relation précédente (noté _x) 
 predict _x
 
* On calcule ensuite la régression de y par rapport à x, _x 
regress y x _x

* Le coefficient de _x est significativement différent de 0. Nous ne sommes pas en mesure d'accepter HO.
*  Nous avons donc Cov(xt, et) différente de 0

******************************************************** 2ème étape 
* Nous faisons la régression simple de y par rapport à x
regress y x

* Cependant la méthode des MCO n'est pas applicable. L'estimateur avi est donné par (la formule suivante
* calcul déjà fait au préalable)
matrix avi=inv(Z'*X)*Z'*Y
matlist avi

* Le modèle estimé par la méthode des variables instrumentales est donc : y = 2.15 +0.79
* Ces coefficients sont à comparer avec ceux des mco qui sont donnés par :
matrix amco=inv(X'*X)*X'*Y
matlist amco

* Nous pouvons calculer l'estimation de la variance de l'erreur 
matrix variancerésiduvi= (1/18)*(evi'*evi)
matlist variancerésiduvi

* Nous pouvons calculer la matrice des variances et covariances 
 matrix varcovarvi= variancerésiduvi*inv(Z'*X)*(Z'*Z)*inv(X'*Z)
 matlist varcovarvi
 
