 *CORRIGE DE L'EXERCICE CHAPITRE 7- EXERCICE 1
 *Dalila Chenaf-Nicet  Université de Bordeaux.
       
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C7EX1 avant d'ouvrir le do.fileC7EX1 qui est fichier programme. 
 
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run Execute en haut à droite de la barre de menu du dofile)
* pour démarrer 
 
  
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.


*                    CHAPITRE 7 EXERCICE 1
                     *Estimation des paramètres d'un modèle autorégressif à erreurs liées


* On régress P en fonction de pe et de po retardé d'une période (L.po). L étant l'opérateur retard sous stata.
* Il faut comme toujours préciser quelle est la variable du temps avant de faire une régression en séries  temporelle 
* avec le code "tsset"

tsset date
reg po pe L.po

estat dwatson

* La statistique de DW laisse augurer d'une autocorrélation (dw= 0.62). Cependant dans le cas de la présence de la variable 
* explique décalée d'une période faisant partie des variables exxplicatives le h durbin doit être privilégié.
* On peut aussi utiliser le 'bgtest, lags(1)' qui est le Breusch-Godfrey LM statistic sous stata ou le durbinh avec les codes 
* suivants :  

durbinh

* ou 

bgtest, lag(1)

* Attention la fonction durbinh (de même pour bgtest) n'est pas automatiquement installée dans toutes les versions de STATA
* Il faut alors télécharger le package à partir de l'aide de stata.

* Il faut a présent comparer le modèle brut avec le modèle en différence. L'opérateur différence sous stata est D. 
* On fait donc la régression suivante :

regress D.po D.L.po D.pe
estat dwatson

* Nous remarquons que les différences entre les coefficients de régression sont assez faibles (0.224 et 0.240) pour a1 
* et (0.622 et 0.598) pour a2.
* Cependant pour des raisons pédagoqiques on peut proposer la méthode de correction d'autocorrélation des erreurs de 
* Hildreth-Lu qui peut être obtenue de deux manières sous stata (Code Prais ou code hlu)

* La première donne une estimation directe
prais po pe L.po

* La deuxième nécessite que l'on crée au préalable la variable po retardée.
gen poretardé=L.po
hlu po pe  poretardé

* Les prix officiels de la période sont donc plus influencés par les prix réellement pratiqués en t que par les prix officiels
* de l'années précédente.
