*CORRIGE DE L'EXERCICE CHAPITRE 7- EXERCICE 4
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C7EX4 avant d'ouvrir le do.fileC7EX4 qui est le fichier programme. 
  
* Attention l'exercice 3 utilise comme pour l'exercice 2 le même fichier de données excel (noté dans l'ouvrage C7EX2)
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile)
* pour démarrer le programme. Il sera exécuté dans son intégralité.
 
  
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.

 
 *               CHAPITRE 7 EXERCICE 4
 *Estimation des coefficient d'un modèle selon une spécification des retards de Koyck et une distribution de Pascal

* On commence par préciser la variable du temps
 tsset date
 
 * On suppose que les coefficients du modèle à retards échenlonnés suivent une progresion géométrique.
 * L'estimation des paramètres s'effectue sous la forme d'un modèle autorégressif à autocorrélation des erreurs.
 
 * Nous créons les valeurs retardées
 gen Ly=L.y
 gen L2y= L2.y
 
 *Les résultats sont les suivants :
regdw y Ly x 

* Nous utilisons les MCO car la méthode d'autocorrélation des erreurs envisagée en I donne des résultats identiques
* Nous obtenons, la valeur des coefficients

scalar alpha=_b[Ly]
display alpha

scalar ahat0=_b[x]
display ahat0

scalar bhat0=_b[_cons]/(1-alpha)
display bhat0

* Le modèle peut donc s'écrire
* yt = alpha*yt-1  + ahat0*xt - cons + et
* yt = 0.907*yt-1  + 0,179*xt - 222,23+ et

* Nous supposons maintenant que les coefficients suivent une distribution Pascal

regdw y Ly L2y x

* Il s'agit donc d'estimer des modèles autorégressifs d'ordre 1, 2, 3, etc. afin de déterminer l'ordre. Après avoir tenté 
* plusieurs solutions nous retenons un modèle autorégressif d'ordre 2 (le modèle d'ordre 1 est déjà réalisé)

scalar alpha1=_b[L2y]
display  alpha1
scalar alpha11=(-alpha1)^(1/2)
display alpha11

scalar ahat01=_b[x]
display ahat01

scalar const=_b[_cons]
display const

scalar bhat01=const/(1-2*alpha11+alpha11*alpha11)
display bhat01

*Le modèle estimé est alors :
regress y Ly L2y x


* ***********Le calcul des élasticités 

* On crée les variables en Log
gen Logy=log(y)
gen Logx =log(x)

gen LLy=L.y
gen LogLLy=log(LLy)

regdw Logy LogLLy Logx

* L'élasticité est donnée par :
 scalar elt= _b[Logx]/(1-_b[LogLLy])
 display elt
 
 *L'élasticité de long terme est donc égale à 1,94. Nous somme dans la zone de rendements croissants.
 * Lorsque le profit augmente par exemple de 10%, l'investissement à long terme augmente de 19,4%
