*CORRIGE DE L'EXERCICE CHAPITRE 7- EXERCICE 5
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C7EX5 avant d'ouvrir le do.fileC7EX5 qui est le fichier programme. 
  
* Attention l'exercice 5 utilise comme pour l'exercice 2 le même fichier de données excel (noté dans l'ouvrage C7EX2)
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run 
*(Execute en haut à droite de la barre de menu du dofile) pour démarrer le programme. Il sera exécuté dans son intégralité.
 
  
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.

 *                                    CHAPITRE 7 EXERCICE 5
                  *Estimation d'un modèle d'ajustement partiel et d'anticipations adaptatives
 
 * On commence par préciser la variable du temps
tsset date

* Nous estimons un modèle autorégresif d'ordre 1 avec autocorrélation des erreurs (Hildrethb-Lu)

* Nous créons une variable retard au préalable

gen Ly=L.y

* L'estimation est donnée par :  
 hlu y Ly  x

* Nous récupérons les coefficients nécessaires aux calculs: 

scalar alpha=(1-_b[Ly])
display alpha

scalar ahat0=_b[_inter]/alpha
display ahat0

scalar ahat1=_b[x]/alpha
display ahat1

* Le modèle d'ajustement partiel est donc : 
* yt = ahat0 + alpha*xt+ et
* Le modèle d'anticipations adaptative
* yt = ahat0 + alpha*xt(puissance p) + et
* avec xt(puissance p) _ xt-1 (puissance p) = alpha * (xt-xt(puissance p-1)
