*CORRIGE DE L'EXERCICE CHAPITRE 8- EXERCICE 3
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C8EX3 avant d'ouvrir le do.fileC8EX3 qui est le fichier programme. 
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run  (Execute en haut à droite de la barre de menu du dofile).
* pour démarrer le programme. Il sera exécuté dans son intégralité.

* Il est possible en sélectionnant les étapes du programme de l'exécuter pas à pas.
  
 
                           * CHAPITRE 8 EXERCICE 3
                            *Le modèle de Klein
 
 * 1 - Distinguer les variables exogènes des variables endogènes.
 
* Le modèle comporte 6 équations et 11 variables
* 3 équations sont des identités (celle du capital K ; celle du profit P et celle de la production industrielle X)
* Les variables exogènes sont celles qui ne sont pas expliquées dans le modèle
*       - Pt-1 , Kt-1 , Kt-1 = 3 variables
 
* Il faut y ajouter : la tendance, les dépenses du gouvernement, les salaires des fonctionnaires Wp et les impôts nommés tax.
* Soit au total = 4 variables
* Cependant comme précisé dans l'ouvrage il faut penser au vecteur colonne de 1 (nécessaire au caclul de la constante.
* Ce vecteur unité sera nommé U comme dans l'ouvrage et sera considéré comme une variable exogène
* Soit la création de la variable U
gen u = 1

* On a donc un total de 3+ 4 + 1 = 8 variables exogènes. Donc k=8
  
* Les variables endogènes sont : la consommation cons, l'investissement I, les salaires w : soit 3 variables.
* Il faut rajouter les endogènes des identités : la production industrielle X, les profits P, et le capital K.
* Soit un total g = 6 variables endogènes.
  
*2 - Les estimations par les MCO 

* Il faut indiquer la variable du temps
  tsset date
  
*Il faut créer la variable ww qui nous donne la variable totalisant les deux formes de salaires (w et wp)

   gen ww=w+wp
   
 * On peut à présent faire la 1ere régression de l'équation E1
 
   regress cons p L.p ww
   
 * La régression de l'équation E2 donne (attention la variable noté k dans le fichier est en fait la variable kt-1 de l'exercice).
 
 regress i p L.p k
  
 * La régression de E3
 regress w x l.x trend
 
* 3 - Les estimateurs des MCO sont biaisés. Nous devons utiliser d'autres méthodes tout précisant les conditions d'identification.

* pour E1 : g-g'+k-k'+r=9 et g-1=5 : Elle est sur-identifiée
* pour E2 : g-g'+k-k'+r=9 et g-1=5 : Elle est sur-identifiée
* pour E3 : g-g'+k-k'+r=9 et g-1=5 : Elle est sur-identifiée
* On peut donc utiliser les DMC

* 4 - Nous appliquons les DMC pour chacune des équations en utilisant différentes méthodes

* //////////Soit le calcul pour E1 en procédant pas à pas

* Il faut créer kt qui est égale a I+kt-1 (attention une fois encore kt-1 et noté k dans la base de données)

gen kt = k+i

* Il faut ensuite régresser P et W qui sont dans la fonction E1 et utiliser leurs valeurs phat et what estimées dans E1

regress p L.p k L.x wp trend g tax u

* A partir de cette régression on récupére p ajusté (phat)
predict residup, re
gen phat=p-residup

regress w L.p k L.x wp trend g tax u

* A partir de cette régression on récupére w ajusté (what)
predict residuw, re
gen what=w-residuw

* On estime l'équation E1 en remplaçant p et w par leur valeur estimée, en posant que (w+wp)=ww est remplacé par
* (what+wp)=wwhat
gen wwhat=what+wp

regress cons phat L.p wwhat


* //////////Soit le calcul pour E2 en utilisant la programmation de Stata pour les DMC
 
 ivregress 2sls i L.p k  (p =L.p k L.x wp trend g tax)
 
 
* //////////Soit le calcul pour E3 en utilisant la programmation de Stata pour les DMC
 
 ivregress 2sls w trend L.x  (x =L.p k L.x wp trend g tax)
 
 * Il est possible d'utiliser les triples moindres carrés

tsset date
  reg3 (cons p L.p ww ) ( i p L.p k ) (w x L.x trend ), exo(g wp tax) endog(x p k)  
  
* Dans le dernier modèle nous utilisons la programmation "sem"  de Stata qui résout le modèle via la procédure du maximum 
* de vraisemblance à information compléte. sem = structural equation modeling est un module de programmation à part entière dans stata 
* qui fait du coup l'objet d'une documentation à part. Nous ne rentrerons pas dans tous les détails de cette programmation qui suit :
  
   
  sem (cons<- p L.p ww  ) ///
  (i <- p L.p k ) ///
  (w<- trend x L.x ), cov(e.cons*e.w) 
