*CORRIGE DE L'EXERCICE CHAPITRE 9- EXERCICE 1
*Dalila Chenaf-Nicet  Université de Bordeaux.
        
* Tout d'abord s'assurer d'avoir ouvert le fichier de données stata C9EX1 avant d'ouvrir le do.fileC9EX1 qui est le fichier programme. 
  
* Une fois le fichier de données ouvert ainsi que le do-file apppuyer sur Run (Execute en haut à droite de la barre de menu du dofile) 
* pour démarrer le programme. Il sera exécuté dans son intégralité.
 
* Toutefois il est possible en sélectionnant les parties du programme de l'exécuter pas à pas afin de voir apparaître pas à pas les 
* différents résultats.

 
                         * CHAPITRE 9 EXERCICE 1
                         * Exemple d'application des tests de racine unitaire au CAC40

* Il faut tout d'abord créer la variable qui matérialisera le temps (nous somme bien avec des séries temporelles !!)

gen date =[_n]

* Puis indiquer que cette nouvelle variable représente le temps
tsset date

* Il est tout d'abord possible de faire le graphe de la variable CAC
twoway (line cac date)

* Il est demandé de fournir les fonctions d'autocorrélation simples et partielles pour 15 retards

* Sous Stata on peut demander séparément AC et PAC (on obtient dans ce cas les intervalles de confiance)

ac cac, level(95) lag(15)
 pac  cac,  lag(15)

 * pour obtenir AC et PAC avec les intervalles de confiance il faut utiliser les programmes
* ac et pac. 
* Les bornes de l'intervalle de confiance sont données par les zones grisées des graphiques .
* Chaque terme qui sort de ces intervalles est donc significativement différent de 0 
* Stata fournit ainsi les fonctions d'autocorrélation simple (AC) et partielle (PAC) avec la stat Q de Ljung box

* On peut aussi demander le corrélogramme dans son intégralité par le code suivant. On obtient en même temps la Stata Ljung Box

corrgram cac, lag(15)

* Le test Q pour 15 retards permet de refuser l'hypothèse de nullité des coeffcients.
* La série n'est donc pas stationnaire.

* 2 - Il s'agit de faire à présent le test de DF
 
 
*////Selon le modèle 3 : avec constante et trend. On régresse  1'equation :
 dfuller cac , trend regress
 
 * Le coefficient de la tendance n'est pas significatif et on rejette l'hypothèse d'un processus TS
 * La statistique du test de CAC, to=-2,054 >-3,41, on accepte HO. Il y a une racine unitaire
 

*////Selon le modèle 2 : avec constante sans trend. On régresse 1'equation :
 dfuller cac ,  regress
 
 * La constante n'est pas significative à 5% (certes elle l'est a 6%) il n'y a donc pas de dérive
 * La statistique du test de CAC, to=-1.806 >-2.860, on accepte HO. Il y a une racine unitaire
 
 * *////Selon le modèle 1 : sans constante sans trend. On régresse  1'equation :
 dfuller cac , noconstant regress
 
  * La statistique du test de CAC, to=0,537 >1.95, on accepte HO. Il y a une racine unitaire
  
  
*/// Si maintenant on veut refaire les calculs mais avec 4 retards cela donne :

*////Selon le modèle 3 : avec constante et trend. On régresse 1'equation
 dfuller cac , trend lag(4) regress
 
 * Le coefficient de la tendance n'est pas significatif et on rejette l'hypothèse d'un processus TS
 * La statistique du test de CAC, to=-2,054 >-3,41, on accepte HO. Il y a une racine unitaire.
 

*////Selon le modèle 2 : avec constante sans trend. On régresse1'equation :
 dfuller cac ,  lag(4) regress
 
 * La constante est  significative à 5% (certes elle l'est a 6%) il y a donc une dérive.
 * La statistique du test de CAC, to=-1.806 >-2.860, on accepte HO. Il y a une racine unitaire.
 
* On peut passer à ce niveau la variable en différence première pour la stationnariser.

* On peut aussi faire un test Phillips-Perron pour confirmer notre analyse.
 
pperron cac, trend regress

pperron cac, regress

pperron cac, noconstant regress

* On peut aussi faire un  test Kpss pour confirmer notre analyse.
kpss cac, maxlag(6)
kpss cac, maxlag (6) notrend

* On peut aussi faire le test de Jarque bera sur la série en différence.
gen Dcac=D.cac
corrgram Dcac, lag(15)
ac Dcac
pac Dcac
jb Dcac
sktest Dcac
 histogram Dcac

